/*******
svmvia, an implementation of the full regularization path for support vector machines
Copyright (C) 2007 Oliver Serang
Written by Oliver Serang at the Department of Genome Sciences at the University of Washington

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*********/

#ifndef BASIC_H_
#define BASIC_H_

// several useful functions for libraries

extern double DEGREE, BIAS, GAMMA, LAMBDA_MIN;
extern bool CACHE;
extern int K_TYPE;
extern int ERR_MODE;
extern bool VERBOSE;
extern bool PRIMAL_HYPERPLANE;

class seq;
class matrix;

#define TOL 1e-3

double max(double a, double b);
double min(double a, double b);
int max(int a, int b);
int min(int a, int b);
double sign(double d);

double randReal(double d);

void swap(double & a, double & b);

double kFunction(const seq & lhs, const seq & rhs);
double rbfKernel(const seq & lhs, const seq & rhs);
double polyKernel(const seq & lhs, const seq & rhs);

const double infinity = 1e20;
const double epsilon = 1e-3;

double square(double x);

extern matrix kernelMat;

#endif
