/*******
svmvia, an implementation of the full regularization path for support vector machines
Copyright (C) 2007 Oliver Serang
Written by Oliver Serang at the Department of Genome Sciences at the University of Washington

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*********/

#include <iostream>
#include "runSVM.h"
#include "basic.h"

#include <fstream>

using namespace std;

int main (int argc, char * argv[])
{
  if (argc == 4)
    {
      ifstream fin1(argv[1]);
      if (fin1.fail())
	{
	  cerr << "error: could not access model file" << endl << endl;
	  exit(1);
	}
      fin1.close();

      ifstream fin2(argv[2]);
      if (fin2.fail())
	{
	  cerr << "error: could not access input file" << endl << endl;
	  exit(1);
	}
      fin2.close();

      ofstream fin3(argv[3]);
      if (fin3.fail())
	{
	  cerr << "error: could not access output file" << endl << endl;
	  exit(1);
	}
      fin3.close();

      runSVM thinker;

      thinker.loadSVM(argv[1]);
      thinker.predict(argv[2], argv[3]);
    }
  else
    {
      cerr << "usage: <model file> <input file> <destination file>" << endl << endl;
    }

  return 0;
}

