/*******
svmvia, an implementation of the full regularization path for support vector machines
Copyright (C) 2007 Oliver Serang
Written by Oliver Serang at the Department of Genome Sciences at the University of Washington

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*********/

#ifndef RUNSVM_H_
#define RUNSVM_H_

#include <iomanip>
#include "seq.h"
#include <fstream>
#include "set.h"
#include "matrix.h"
#include "basic.h"
#include <string>
#include "svm.h"

using namespace std;

class runSVM
{

 public:
  runSVM() {}
    SVM hastie;
  //  hastieSVM hastie;
  double bestError;

  void loadSVM(char * fname);
  void saveSVM(char * fname);
  void predict(char * fname, char * oname);

  void normalize(matrix & lhs);

  matrix x;
  matrix x_val;
  seq y, y_val;

  int n, n_val;
  int x_dim, x_dim_val;

  runSVM(char * fname, char * vname);
  double run();
};

#endif
