/*******
svmvia, an implementation of the full regularization path for support vector machines
Copyright (C) 2007 Oliver Serang
Written by Oliver Serang at the Department of Genome Sciences at the University of Washington

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*********/

#ifndef SET_H_
#define SET_H_

#include <iostream>
#include <vector>
using namespace std;

// a dense set implementation

class set
{
 public:
  vector<int> data;

  set()
    {
    }

  set(int size);

  void fill(int cap);
  void clear();

  int size() const
  {
    return data.size();
  }

  void add(int i);

  int search(int i);

  int maxIndex() const;
  void remove(const set & rhs);
  void remove(int i);
  void removeIndex(int index);

  int & operator [](int k);
  int operator [](int k) const;

  set operator[] (const set & rhs) const;

  bool contains(int i);

  void join(const set & rhs);
};

ostream & operator << (ostream & os, set rhs);

#endif
